#include <bits/stdc++.h>

using namespace std;

int check(int a, int b, int k, int* O)
{
    for(int i = 0; i < k; i++)
    {
        if(O[i] >= b)
            break;
        if(O[i] >= a)
            return 0;
    }
    return 1;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, Q;
    cin >> n >> Q;
    int a, b, k = 0;
    int O[n];

    int N[n];
    int R[Q];
    for(int i = 0; i < n; i++)
    {
        cin >> N[i];
        if(N[i] == 0)
        {
            O[k] = i;
            k++;
        }
    }

    for(int i = 0; i < Q; i++)
    {
        cin >> a >> b;
        R[i] = check(a-1, b, k, O);
    }

    for(int i = 0; i < Q; i++)
        cout << R[i] << endl;

    return 0;
}